package mindex.distance;

import messif.algorithms.AlgorithmMethodException;
import messif.objects.LocalAbstractObject;
import mindex.MetricIndex;

/**
 * This class calculates distance between a query object represented by query-pivot distances
 *  and a data object PPP using the "sum of query-pivot distance differences" normalized by
 *  mutual distances between the pivots.
 * 
 * @author David Novak, Masaryk University, Brno, Czech Republic, david.novak@fi.muni.cz
 */
@Deprecated
public class HyperplaneDistCalculator extends QueryPivotDistDiffCalculator {

    /** M-Index configuration and method provider */
    protected final MetricIndex mIndex;
    
    /**
     * Creates the calculator from given query object and the M-Index configuration
     * @param queryObject query object
     * @param mIndex M-Index configuration
     */
    public HyperplaneDistCalculator(LocalAbstractObject queryObject, MetricIndex mIndex) throws AlgorithmMethodException {
        super(queryObject, mIndex);
        this.mIndex = mIndex;
    }

    
    // ************** Query-PPP distance calculation ***************//

    @Override
    public float getQueryDistance(short[] ppp) {        
        float sum = 0f;
        for (int i = 0; i < getMaxLevel(ppp.length); i++) {
            float add = Math.max(queryPivotDistances[ppp[i]] - queryPivotDistances[queryPP[i]], 0f);
            if (add > 0) {
                add = 0.5f * add * (queryPivotDistances[ppp[i]] + queryPivotDistances[queryPP[i]]) 
                        / mIndex.getPivotsDistance(ppp[i], queryPP[i]);
            }
            sum += add;
        }
        return sum;
    }
    

}
